org.apache.xml.dtm.ref

## Class DTMNamedNodeMap

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMNamedNodeMap

- All Implemented Interfaces:
    NamedNodeMap

      public class DTMNamedNodeMap
      extends java.lang.Object
      implements NamedNodeMap

  DTMNamedNodeMap is a quickie (as opposed to quick) implementation of the DOM's NamedNodeMap interface, intended to support DTMProxy's getAttributes() call.

  ***** Note: this does _not_ current attempt to cache any of the data; if you ask for attribute 27 and then 28, you'll have to rescan the first 27. It should probably at least keep track of the last one retrieved, and possibly buffer the whole array.

  ***** Also note that there's no fastpath for the by-name query; we search linearly until we find it or fail to find it. Again, that could be optimized at some cost in object creation/storage.

  Usage:
    **For internal use only**

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DTMNamedNodeMap.DTMException` Simple implementation of DOMException.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DTMNamedNodeMap(DTM dtm, int element)` Create a getAttributes NamedNodeMap for a given DTM element node

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getLength()` Return the number of Attributes on this Element
    `Node` | `getNamedItem(java.lang.String name)` Retrieves a node specified by name.
    `Node` | `getNamedItemNS(java.lang.String namespaceURI, java.lang.String localName)` Retrieves a node specified by local name and namespace URI.
    `Node` | `item(int i)` Returns the `index`th item in the map.
    `Node` | `removeNamedItem(java.lang.String name)` Removes a node specified by name.
    `Node` | `removeNamedItemNS(java.lang.String namespaceURI, java.lang.String localName)` Removes a node specified by local name and namespace URI.
    `Node` | `setNamedItem(Node newNode)` Adds a node using its `nodeName` attribute.
    `Node` | `setNamedItemNS(Node arg)` Adds a node using its `namespaceURI` and `localName`.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DTMNamedNodeMap

          public DTMNamedNodeMap(DTM dtm,
                         int element)

      Create a getAttributes NamedNodeMap for a given DTM element node
      Parameters:
        `dtm` - The DTM Reference, must be non-null.
        `element` - The DTM element handle.

  - ### Method Detail

    - #### getLength

          public int getLength()

      Return the number of Attributes on this Element
      Specified by:
        `getLength` in interface `NamedNodeMap`
      Returns:
        The number of nodes in this map.

    - #### getNamedItem

          public Node getNamedItem(java.lang.String name)

      Retrieves a node specified by name.
      Specified by:
        `getNamedItem` in interface `NamedNodeMap`
      Parameters:
        `name` - The `nodeName` of a node to retrieve.
      Returns:
        A `Node` (of any type) with the specified `nodeName`, or `null` if it does not identify any node in this map.

    - #### item

          public Node item(int i)

      Returns the `index`th item in the map. If `index` is greater than or equal to the number of nodes in this map, this returns `null`.
      Specified by:
        `item` in interface `NamedNodeMap`
      Parameters:
        `i` - The index of the requested item.
      Returns:
        The node at the `index`th position in the map, or `null` if that is not a valid index.

    - #### setNamedItem

          public Node setNamedItem(Node newNode)

      Adds a node using its `nodeName` attribute. If a node with that name is already present in this map, it is replaced by the new one.
      As the `nodeName` attribute is used to derive the name which the node must be stored under, multiple nodes of certain types (those that have a "special" string value) cannot be stored as the names would clash. This is seen as preferable to allowing nodes to be aliased.
      Specified by:
        `setNamedItem` in interface `NamedNodeMap`
      Parameters:
        `newNode` - node to store in this map. The node will later be accessible using the value of its `nodeName` attribute.
      Returns:
        If the new `Node` replaces an existing node the replaced `Node` is returned, otherwise `null` is returned.
      Throws:
        `DOMException` - WRONG_DOCUMENT_ERR: Raised if `arg` was created from a different document than the one that created this map.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this map is readonly.
        INUSE_ATTRIBUTE_ERR: Raised if `arg` is an `Attr` that is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.

    - #### removeNamedItem

          public Node removeNamedItem(java.lang.String name)

      Removes a node specified by name. When this map contains the attributes attached to an element, if the removed attribute is known to have a default value, an attribute immediately appears containing the default value as well as the corresponding namespace URI, local name, and prefix when applicable.
      Specified by:
        `removeNamedItem` in interface `NamedNodeMap`
      Parameters:
        `name` - The `nodeName` of the node to remove.
      Returns:
        The node removed from this map if a node with such a name exists.
      Throws:
        `DOMException` - NOT_FOUND_ERR: Raised if there is no node named `name` in this map.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this map is readonly.

    - #### getNamedItemNS

          public Node getNamedItemNS(java.lang.String namespaceURI,
                            java.lang.String localName)

      Retrieves a node specified by local name and namespace URI. HTML-only DOM implementations do not need to implement this method.
      Specified by:
        `getNamedItemNS` in interface `NamedNodeMap`
      Parameters:
        `namespaceURI` - The namespace URI of the node to retrieve.
        `localName` - The local name of the node to retrieve.
      Returns:
        A `Node` (of any type) with the specified local name and namespace URI, or `null` if they do not identify any node in this map.
      Since:
        DOM Level 2

    - #### setNamedItemNS

          public Node setNamedItemNS(Node arg)
                              throws DOMException

      Adds a node using its `namespaceURI` and `localName`. If a node with that namespace URI and that local name is already present in this map, it is replaced by the new one.
      HTML-only DOM implementations do not need to implement this method.
      Specified by:
        `setNamedItemNS` in interface `NamedNodeMap`
      Parameters:
        `arg` - A node to store in this map. The node will later be accessible using the value of its `namespaceURI` and `localName` attributes.
      Returns:
        If the new `Node` replaces an existing node the replaced `Node` is returned, otherwise `null` is returned.
      Throws:
        `DOMException` - WRONG_DOCUMENT_ERR: Raised if `arg` was created from a different document than the one that created this map.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this map is readonly.
        INUSE_ATTRIBUTE_ERR: Raised if `arg` is an `Attr` that is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.
      Since:
        DOM Level 2

    - #### removeNamedItemNS

          public Node removeNamedItemNS(java.lang.String namespaceURI,
                               java.lang.String localName)
                                 throws DOMException

      Removes a node specified by local name and namespace URI. A removed attribute may be known to have a default value when this map contains the attributes attached to an element, as returned by the attributes attribute of the `Node` interface. If so, an attribute immediately appears containing the default value as well as the corresponding namespace URI, local name, and prefix when applicable.
      HTML-only DOM implementations do not need to implement this method.
      Specified by:
        `removeNamedItemNS` in interface `NamedNodeMap`
      Parameters:
        `namespaceURI` - The namespace URI of the node to remove.
        `localName` - The local name of the node to remove.
      Returns:
        The node removed from this map if a node with such a local name and namespace URI exists.
      Throws:
        `DOMException` - NOT_FOUND_ERR: Raised if there is no node with the specified `namespaceURI` and `localName` in this map.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this map is readonly.
      Since:
        DOM Level 2

Copyright © 2014 Apache XML Project. All Rights Reserved.